Package com.emc.d2fs.interfaces

# Interface ID2LifeCycleService

All Superinterfaces:
  `ID2fsService`

public interface ID2LifeCycleService extends ID2fsService
D2 Life Cycle Management Services Interface.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `LifeCycleResult`
  `apply(Context context, String docId, String targetState, String event)`
  Apply lifecycle state
  `LifeCycleResult`
  `changeState(Context context, String docId, String targetState, String event, String operation, List<Attribute> parameters)`
  Change lifecycle state of document
  `List<LifeCycleResult>`
  `changeStateMass(Context context, String docId, String targetState, String event, String operation, List<Attribute> parameters)`
  `LifeCycleResult`
  `changeStateOnEvent(Context context, String docId, String targetState, String event)`
  Change lifecycle state on event handle
  `List<Attribute>`
  `getChangeStateSignoffParameters(Context context, String docId, String targetState)`
  Return the signoff parameters for a target state
  `LifeCycleResult`
  `nextStateOnEvent(Context context, String docId, String event)`
  Get next states for specified event
  `LifeCycleResult`
  `nextStates(Context context, String docId, String operation)`
  Get next states for specified operation
  `LifeCycleResult`
  `testChangeStateConditions(Context context, String docId, String targetState, String event)`
  Check change state conditions
  `LifeCycleResult`
  `testNextState(Context context, String docId)`
  Check next state result
  `LifeCycleResult`
  `testTransition(Context context, String docId, String operation)`
  Check transition result

  ### Methods inherited from interface com.emc.d2fs.interfaces.ID2fsService

  `isRemote, setRemote`

- ## Method Details

  - ### changeState

    LifeCycleResult changeState(Context context, String docId, String targetState, String event, String operation, List<Attribute> parameters) throws Exception
    Change lifecycle state of document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `targetState` - String value of targeted state name
      `event` - String value of event name
      `operation` - String value of operation name
      `parameters` - `Attribute` list of parameters
      - list: DF_STRING - String containing a list of attribute names to be set(separated by AttributeUtils.SEPARATOR_VALUE)
      - signoff_required: DF_BOOLEAN - (optional; default false)Indicate that signoff is required.
      - signoff_intention: DF_BOOLEAN - (optional) signoff intention
    Returns:
      `LifeCycleResult` object
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### changeStateMass

    List<LifeCycleResult> changeStateMass(Context context, String docId, String targetState, String event, String operation, List<Attribute> parameters) throws Exception
    Throws:
      `Exception`

  - ### testChangeStateConditions

    LifeCycleResult testChangeStateConditions(Context context, String docId, String targetState, String event) throws Exception
    Check change state conditions
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `targetState` - String value of state name
      `event` - String value of event name
    Returns:
      `LifeCycleResult` object
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### changeStateOnEvent

    LifeCycleResult changeStateOnEvent(Context context, String docId, String targetState, String event) throws D2fsException
    Change lifecycle state on event handle
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `targetState` - String value of state name
      `event` - String value of event name
    Returns:
      `LifeCycleResult` object
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### nextStateOnEvent

    LifeCycleResult nextStateOnEvent(Context context, String docId, String event) throws D2fsException
    Get next states for specified event
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `event` - String value of event name
    Returns:
      `LifeCycleResult` object
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### nextStates

    LifeCycleResult nextStates(Context context, String docId, String operation) throws D2fsException
    Get next states for specified operation
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `operation` - String value of operation name
    Returns:
      `LifeCycleResult` object
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### testNextState

    LifeCycleResult testNextState(Context context, String docId) throws D2fsException
    Check next state result
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
    Returns:
      `LifeCycleResult` object
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### testTransition

    LifeCycleResult testTransition(Context context, String docId, String operation) throws D2fsException
    Check transition result
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `operation` - String value of operation name
    Returns:
      `LifeCycleResult` object
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### apply

    LifeCycleResult apply(Context context, String docId, String targetState, String event) throws D2fsException
    Apply lifecycle state
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `targetState` - String value of targeted state name
      `event` - String value of event name
    Returns:
      `LifeCycleResult` object
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### getChangeStateSignoffParameters

    List<Attribute> getChangeStateSignoffParameters(Context context, String docId, String targetState) throws D2fsException
    Return the signoff parameters for a target state
    Parameters:
      `context` - `Context` object containing informations about client/session
      `docId` - String value of document id
      `targetState` - String value of targeted state name
    Returns:
      A list of `Attribute` objects containing signoff parameters
    Throws:
      `D2fsException`
    Since:
      4.1.0